<id>
CSS Buttons for YaBB 2.2
</id>

<version>
1.0
</version>

<mod info>

This mod will add "soft coded" css driven buttons to your board and give you the option
to change the graphics and text attributes for buttons in the css wysiwyg editor.
Added a new extra "Menu.def" to load all 3 menu modes from only one file. The format
for adding new buttons to the new Menu.def file compared to "old style" is:

hash-key,icon|hash-for-text|key-for-text|hash-for-alt|key-for-alt|backgr-style|template-or-mod

For the "Home" button it looks like this:

New Menu.def style:
home,home|img_txt|103|img_txt|103|imgmenu|tmp

Menu0.def:
'home' => "<img src=\"$imagesdir/home.$imgext\" alt=\"$img_txt{'103'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'103'}</span>",

Menu1.def:
'home' => "<span class=\"imgmenu\">$img_txt{'103'}</span>",

Menu2.def:
'home' => "<img src=\"$html_root/Buttons/$button_language/home.$imgext\" alt=\"$img_txt{'103'}\" border=\"0\" />",


Apply this mod.

Upload (in ASCII mode):
-----------------------
cgi-bin/yabb2/Admin/ManageTemplates.pl
cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Languages/English/Menu.lng
cgi-bin/yabb2/Languages/English/Templates.lng
cgi-bin/yabb2/Sources/Load.pl


Upload from the zip package (in ASCII mode):
--------------------------------------------
cgi-bin/yabb2/Sources/Menu.pl
cgi-bin/yabb2/Variables/Menu.def
yabbfiles/Templates/Forum/default.css
yabbfiles/Templates/Forum/yabb21.css


Upload from the zip package (in Binary mode):
---------------------------------------------
yabbfiles/Buttons/*.png
yabbfiles/Templates/Forum/default/buttonsep.png
yabbfiles/Templates/Forum/default/collapse.gif
yabbfiles/Templates/Forum/default/expand.gif
yabbfiles/Templates/Forum/default/knapbagrms02.gif
yabbfiles/Templates/Forum/default/knapyellow.gif
yabbfiles/Templates/Forum/default/yim.gif

</mod info>

<author>
Carsten
</author>


<edit file>
Admin/ManageTemplates.pl
</edit file>

<search for>
	$stylestr = "";
</search for>

<add before>
	$cssbuttons = 0;
</add before>

<search for>
		$stylestr .= qq~$style_sgl ~;
</search for>

<add before>
		$style_sgl =~ s/\.\.\/\.\.\/Buttons/$html_root\/Buttons/g;
</add before>

<search for>
		$containerstyle =~ s/.*?(\#container\s*?\{.+?\}).*/$1/ig;
</search for>

<replace>
		$containerstyle =~ s/.*?(\#container.*?\{.+?\}).*/$1/ig;
</replace>

<search for>
	if ($stylestr =~ /\.seperator/) {
</search for>

<add before>
	if ($stylestr =~ /\.buttonleft/ && $stylestr =~ /\.buttonright/ && $stylestr =~ /\.buttonimage/ && $stylestr =~ /\.buttontext/) {
		$cssbuttons = 1;
		$buttonstyle = $stylestr;
		$buttonstyle =~ s/.*?(\.buttontext\s*?\{.+?\}).*/$1/ig;
		$selstyl .= qq~<option value='$buttonstyle'>$templ_txt{'buttontext'}</option>\n~;
		$prevtext = $buttonstyle;
		$prevtext =~ s/\.buttontext\s*?\{(.+?)\}/$1/ig;
		$drawtxtpos = $prevtext;
		$drawtxtpos =~ m/.*?top\s*?\:\s*?(\d{1,2})px.*/i;
		$viewtxty = $1;
		$viewtxty .= "px";
		$drawpos4 = ($1 * 5) + 213;
		$drawpos4 .= "px";
		$buttonleftstyle = $stylestr;
		$buttonleftstyle =~ s/.*?(\.buttonleft\s*?\{.+?\}).*/$1/ig;
		$buttonleftbg = qq~<input type="hidden" id="buttonleftbg" name="buttonleftbg" value="$buttonleftstyle" />\n~;
		$buttonbg = $buttonleftstyle;
		$buttonbg =~ s~.*?($html_root/Buttons/)(.*?)\.(.*)~$2~g;
		$prevleft = $buttonleftstyle;
		$prevleft =~ s/\.buttonleft\s*?\{(.+?)\}/$1/ig;
		$buttonrightstyle = $stylestr;
		$buttonrightstyle =~ s/.*?(\.buttonright\s*?\{.+?\}).*/$1/ig;
		$buttonrightbg = qq~<input type="hidden" id="buttonrightbg" name="buttonrightbg" value="$buttonrightstyle" />\n~;
		$prevright = $buttonrightstyle;
		$prevright =~ s/\.buttonright\s*?\{(.+?)\}/$1/ig;
		$buttonimagestyle = $stylestr;
		$buttonimagestyle =~ s/.*?(\.buttonimage\s*?\{.+?\}).*/$1/ig;
		$buttonimagebg = qq~<input type="hidden" id="buttonimagebg" name="buttonimagebg" value="$buttonimagestyle" />\n~;
		$previmage = $buttonimagestyle;
		$previmage =~ s/\.buttonimage\s*?\{(.+?)\}/$1/ig;
		$drawimgpos = $previmage;
		$drawimgpos =~ m/.*?background\-position\s*?\:\s*?(\d{1,2})px\s*?(\d{1,2})px.*/i;
		$viewimgy = $2;
		$viewimgy .= "px";
		$drawpos1 = ($2 * 5) + 213;
		$drawpos1 .= "px";
		$viewimgx = $1;
		$viewimgx .= "px";
		$drawpos2 = $1 + 213;
		$drawpos2 .= "px";
		$drawimgwd = $previmage;
		$drawimgwd =~ m/.*?padding\s*?\:\s*?\d{1,2}px\s*?\d{1,2}px\s*?\d{1,2}px\s*?(\d{1,2})px.*/i;
		$viewimgpad = $1;
		$viewimgpad .= "px";
		$drawpos3 = $1 + 213;
		$drawpos3 .= "px";
	}
</add before>

<search for>
		$window2style =~ s/.*?(\.windowbg2\s*?\{.+?\}).*/$1/ig;
</search for>

<replace>
		$window2style =~ s/.*?(\.windowbg2.*?\{.+?\}).*/$1/ig;
</replace>

<search for>
		$inputstyle =~ s/.*?(input\s*?\{.+?\}).*/$1/ig;
</search for>

<replace>
		$inputstyle =~ s/.*?(input.*?\{.+?\}).*/$1/ig;
</replace>

<search for>
	$viewstylestart = qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
</search for>

<add before>
if($cssbuttons) {
	$thisbutton = "";
	opendir(DIR, "$htmldir/Buttons");
	@contents = readdir(DIR);
	closedir(DIR);
	$optbuttons = "";
	$x = 1;
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		($tmpname, $tmpside) = split (/\_/, $name);
		$checked = "";
		if ($name eq $buttonbg) { $checked = qq~ checked = "checked"~; }
		if (($extension =~ /gif/i || $extension =~ /png/i) && $tmpside eq "left") {
			$bleft = qq~_left.$extension~;
			$bright = qq~_right.$extension~;
			$thisbutton .= qq~<div style="float: left; width: 99%; margin: 2px; 0; vertical-align: bottom;"><div style="float: left; height: 20px; width: 112px; padding: 0 0 0 6px; background-image: url($html_root/Buttons/$tmpname$bleft); background-repeat: no-repeat; vertical-align: bottom; cursor: pointer;" onclick="updateButtons('$line');">~;
			$thisbutton .= qq~<div style="float: left; height: 20px; padding: 0 80px 0 0; background-image: url($html_root/Buttons/$tmpname$bright); background-position: right; background-repeat: no-repeat; vertical-align: bottom;"><div style="float: left; height: 20px; padding: 0 0 0 25px;"></div></div></div>~;
			$thisbutton .= qq~<div style="float: left; height: 20px;"><input type="radio" name="selbutton" id="selbutton$x" value="$line" class="windowbg2" style="border: 0px; vertical-align: middle;"$checked onclick="updateButtons(this.value);" /> <label for="selbutton$x" style="vertical-align: middle;"><b>$tmpname</b></label></div></div>\n~;
			$x++;
		}
	}

$yymain .= qq~

	<tr>
		<td align="left" class="windowbg2">
		<div style="float: left; width: 99%; padding: 3px;">
			<b>$templ_txt{'buttontext'}</b><br /><span class="small">$templ_txt{'buttondescription'}<br /><br /></span>
		</div>
		<div style="float: left; width: 330px; height: 136px; padding: 3px;">
		<div class="catbg" style="position: relative; top: 0px; left: 5px; width: 280px; text-align: center; border-width: 1px; border-style: outset; padding: 3px 0px;">
		<img src="$forumstylesurl/default/buttonsep.png" style="height: 20px; width: 1px; margin: 0px; padding: 0px; vertical-align: top; display: inline-block;" alt="" border="0" />
		<span id="butleft" style="height: 20px; border: 0px; margin: 1px 1px; background-position: top left; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block; $prevleft">
		<span id="butright" style="height: 20px; border: 0px; margin: 0px; background-position: top right; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block; $prevright">
		<span id="butimage" style="$previmage background-image: url($forumstylesurl/default/home.gif); height: 20px; border: 0px; margin: 0px; background-repeat: no-repeat; vertical-align: top; text-decoration: none; font-size: 18px; display: inline-block;">
		<span id="buttext" style="height: 20px; border: 0px; margin: 0px; padding: 0px; text-align: left; text-decoration: none; vertical-align: top; white-space: nowrap; display: inline-block; $prevtext">$img_txt{'103'}</span>
		</span></span></span>
		<img src="$forumstylesurl/default/buttonsep.png" style="height: 20px; width: 1px; margin: 0px; padding: 0px; vertical-align: top; display: inline-block;" alt="" border="0" />
		</div>
		<div class="catbg" style="position: relative; top: 4px; left: 5px; width: 280px; height: 18px; border-width: 1px; border-style: outset;">
		<span class="small" style="position: absolute; top: 3px; left: 6px;"><b>$templ_txt{'moveicon1'}</b>
		<input class="catbg" name="viewimgy" id="viewimgy" type="text" value="$viewimgy" style="position: absolute; top: 0px; left: 165px; text-align: right; width: 30px; margin: 0px; padding: 0px; border: 0px; font-size: 10px; font-weight: bold; display: inline;" readonly="readonly" /></span>
		<img src="$defaultimagesdir/knapbagrms02.gif" style="position: absolute; top: 0px; left: 209px; z-index: 1; width: 69px; height: 16px;" />
		<img id="knapImg1" src="$defaultimagesdir/knapyellow.gif" class="skyd" style="position: absolute; left: $drawpos1; top: 2px; cursor: pointer; cursor: hand; z-index: 2; width: 13px; height: 15px;" />
		</div>
		<div class="catbg" style="position: relative; top: 8px; left: 5px; width: 280px; height: 18px; border-width: 1px; border-style: outset;">
		<span class="small" style="position: absolute; top: 3px; left: 6px;"><b>$templ_txt{'moveicon2'}</b>
		<input class="catbg" name="viewimgx" id="viewimgx" type="text" value="$viewimgx" style="position: absolute; top: 0px; left: 165px; text-align: right; width: 30px; margin: 0px; padding: 0px; border: 0px; font-size: 10px; font-weight: bold; display: inline;" readonly="readonly" /></span>
		<img src="$defaultimagesdir/knapbagrms02.gif" style="position: absolute; top: 0px; left: 209px; z-index: 1; width: 69px; height: 16px;" />
		<img id="knapImg2" src="$defaultimagesdir/knapyellow.gif" class="skyd" style="position: absolute; left: $drawpos2; top: 2px; cursor: pointer; cursor: hand; z-index: 2; width: 13px; height: 15px;" />
		</div>
		<div class="catbg" style="position: relative; top: 12px; left: 5px; width: 280px; height: 18px; border-width: 1px; border-style: outset;">
		<span class="small" style="position: absolute; top: 3px; left: 6px;"><b>$templ_txt{'iconspace'}</b>
		<input class="catbg" name="viewimgpad" id="viewimgpad" type="text" value="$viewimgpad" style="position: absolute; top: 0px; left: 165px; text-align: right; width: 30px; margin: 0px; padding: 0px; border: 0px; font-size: 10px; font-weight: bold; display: inline;" readonly="readonly" /></span>
		<img src="$defaultimagesdir/knapbagrms02.gif" style="position: absolute; top: 0px; left: 209px; z-index: 1; width: 69px; height: 16px;" />
		<img id="knapImg3" src="$defaultimagesdir/knapyellow.gif" class="skyd" style="position: absolute; left: $drawpos3; top: 2px; cursor: pointer; cursor: hand; z-index: 2; width: 13px; height: 15px;" />
		</div>
		<div class="catbg" style="position: relative; top: 16px; left: 5px; width: 280px; height: 18px; border-width: 1px; border-style: outset;">
		<span class="small" style="position: absolute; top: 3px; left: 6px;"><b>$templ_txt{'movetext'}</b>
		<input class="catbg" name="viewtxty" id="viewtxty" type="text" value="$viewtxty" style="position: absolute; top: 0px; left: 165px; text-align: right; width: 30px; margin: 0px; padding: 0px; border: 0px; font-size: 10px; font-weight: bold; display: inline;" readonly="readonly" /></span>
		<img src="$defaultimagesdir/knapbagrms02.gif" style="position: absolute; top: 0px; left: 209px; z-index: 1; width: 69px; height: 16px;" />
		<img id="knapImg4" src="$defaultimagesdir/knapyellow.gif" class="skyd" style="position: absolute; left: $drawpos4; top: 2px; cursor: pointer; cursor: hand; z-index: 2; width: 13px; height: 15px;" />
		</div>
		</div>
		<div style="float: left; width: 300px; padding: 3px; padding-left: 13px;">
			$thisbutton
		</div>
		$buttonleftbg
		$buttonrightbg
		$buttonimagebg
		</td>
	</tr>

<script type="text/javascript" language="JavaScript1.2">
<!--

var skydobject={
x: 0, temp2 : null, targetobj : null, skydNu : 0, delEnh : 0,
initialize:function() {
	document.onmousedown = this.skydeKnap
	document.onmouseup=function(){ this.skydNu = 0; updateStyles(); }
},
changeStyle:function(deleEnh, knapId) {
	if (knapId == "knapImg1") {
		newypos = parseInt(deleEnh/5);
		thenewstyle = document.allstyles.stylelink.value;
		cssoption = document.allstyles.buttonimagebg.value;
		oldxpos=cssoption.replace(/\.*?background\\-position\\s*?\\:\\s*?(\\d{1,2})\.*/i, "\$1");
		newcssoption=cssoption.replace(/(background\\-position\\s*?\\:\.*?\\d{1,2}px\\s*?)\\d{1,2}(px\\;)/i, "\$1" + newypos + "\$2");
		document.allstyles.buttonimagebg.value = newcssoption;
		re=cssoption.replace(/(.*)/, "\$1");
		thenewstyle=thenewstyle.replace(re, newcssoption);
		document.allstyles.stylelink.value = thenewstyle;
		document.getElementById('butimage').style.backgroundPosition = oldxpos+'px '+newypos+'px';
		document.getElementById('viewimgy').value = newypos+'px';
	}
	if (knapId == "knapImg2") {
		newxpos = parseInt(deleEnh);
		thenewstyle = document.allstyles.stylelink.value;
		cssoption = document.allstyles.buttonimagebg.value;
		oldypos=cssoption.replace(/\.*?background\\-position\\s*?\\:\\s*?\\d{1,2}px\\s*?(\\d{1,2})\.*/i, "\$1");
		newcssoption=cssoption.replace(/(background\\-position\\s*?\\:\.*?)\\d{1,2}(px\\s*?\\d{1,2}px\\;)/i, "\$1" + newxpos + "\$2");
		document.allstyles.buttonimagebg.value = newcssoption;
		re=cssoption.replace(/(.*)/, "\$1");
		thenewstyle=thenewstyle.replace(re, newcssoption);
		document.allstyles.stylelink.value = thenewstyle;
		document.getElementById('butimage').style.backgroundPosition = newxpos+'px '+oldypos+'px';
		document.getElementById('viewimgx').value = newxpos+'px';
	}
	if (knapId == "knapImg3") {
		newimgpad = parseInt(deleEnh);
		thenewstyle = document.allstyles.stylelink.value;
		cssoption = document.allstyles.buttonimagebg.value;
		newcssoption=cssoption.replace(/(padding\\s*?\\:\.*?\\d{1,2}px\\s*?\\d{1,2}px\\s*?\\d{1,2}px\\s*?)\\d{1,2}(px\\;)/i, "\$1" + newimgpad + "\$2");
		document.allstyles.buttonimagebg.value = newcssoption;
		re=cssoption.replace(/(.*)/, "\$1");
		thenewstyle=thenewstyle.replace(re, newcssoption);
		document.allstyles.stylelink.value = thenewstyle;
		document.getElementById('butimage').style.padding = '0px 0px 0px '+newimgpad+'px';
		document.getElementById('viewimgpad').value = newimgpad+'px';
	}
	if (knapId == "knapImg4") {
		newtxtpad = parseInt(deleEnh/5);
		thenewstyle = document.allstyles.stylelink.value;
		allstyleslen = document.allstyles.csselement.length;
		for (i = 0; i < allstyleslen; i++) {
			tmpselelement = document.allstyles.csselement[i].value;
			if (tmpselelement.match(/\\.buttontext/)) {
				cssoption = document.allstyles.csselement.options[i].value;
				newcssoption=cssoption.replace(/(top\\s*?\\:\.*?)\\d{1,2}(px\\s*?\\;)/i, "\$1" + newtxtpad + "\$2");
				document.allstyles.csselement.options[i].value = newcssoption;
			}
		}
		re=cssoption.replace(/(.*)/, "\$1");
		thenewstyle=thenewstyle.replace(re, newcssoption);
		document.allstyles.stylelink.value = thenewstyle;
		document.getElementById('buttext').style.top = newtxtpad+'px';
		document.getElementById('viewtxty').value = newtxtpad+'px';
	}
},
flytKnap:function(e) {
	var evtobj = window.event ? window.event : e
	if (this.skydNu == 1) {
		glX = parseInt(this.targetobj.style.left)
		this.targetobj.style.left = this.temp2 + evtobj.clientX - this.x + "px"
		nyX = parseInt(this.temp2 + evtobj.clientX - this.x)
		if (nyX > glX) retning = "vn"; else retning = "hj";
		if (nyX < 213 && retning == "hj") { this.targetobj.style.left = 213 + "px"; nyX = 213; retning = "vn"; }
		if (nyX > 263 && retning == "vn") { this.targetobj.style.left = 263 + "px"; nyX = 263; retning = "hj"; }
		delEnh = parseInt(nyX)-213
		var knapObj = this.targetobj.id
		skydobject.changeStyle(delEnh, knapObj)
		return false
	}
},
skydeKnap:function(e) {
	var evtobj = window.event ? window.event : e
	this.targetobj = window.event ? event.srcElement : e.target
	if (this.targetobj.className == "skyd") {
		this.skydNu = 1
		this.knapObj = this.targetobj
		if (isNaN(parseInt(this.targetobj.style.left))) this.targetobj.style.left = 0
		this.temp2 = parseInt(this.targetobj.style.left)
		this.x = evtobj.clientX
		if (evtobj.preventDefault) evtobj.preventDefault()
		document.onmousemove = skydobject.flytKnap
	}
}
}

skydobject.initialize()
//-->
</script>
~;
}
</add before>

<search for>
<td id="categorya" class="catbg" width="50%" align="left" valign="middle">
<a href="javascript:;">$templ_txt{'31a'}</a>
</td>
</tr>
</table>
</search for>

<add after>
~;
if($cssbuttons) {
$menusep = qq~<img src="$forumstylesurl/default/buttonsep.png" style="height: 20px; width: 1px; margin: 0px; padding: 0px; vertical-align: top; display: inline-block;" alt="" border="0" />~;
$viewstyleleft = qq~style="height: 20px; border: 0px; margin: 1px 1px; background-position: top left; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block;"~;
$viewstyleright = qq~style="height: 20px; border: 0px; margin: 0px; background-position: top right; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block;"~;
$viewstyleimage = qq~height: 20px; border: 0px; margin: 0px; background-repeat: no-repeat; vertical-align: top; text-decoration: none; font-size: 18px; display: inline-block;~;
$viewstyletext = qq~style="height: 20px; border: 0px; margin: 0px; padding: 0px; text-align: left; text-decoration: none; vertical-align: top; white-space: nowrap; display: inline-block;"~;

$viewstyle .= qq~
<table class="bordercolor" cellpadding="4" cellspacing="1" border="0" width="100%">
<tr>
<td id="cssbuttons" class="windowbg2" width="100%" align="left" valign="top">
<div style="float: left; padding: 4px 0 0 0;">$templ_txt{'buttontext'}</div>
<div style="float: right;">
<a href="javascript:;"><span id="button1l" class="buttonleft" $viewstyleleft title="$img_txt{'145'}"><span id="button1r" class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($forumstylesurl/default/quote.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>$img_txt{'145'}</span></span></span></span></a>$menusep
<a href="javascript:;"><span id="button2l" class="buttonleft" $viewstyleleft title="$img_txt{'66'}"><span id="button2r" class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($forumstylesurl/default/modify.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>$img_txt{'66'}</span></span></span></span></a>$menusep
<a href="javascript:;"><span id="button3l" class="buttonleft" $viewstyleleft title="$img_txt{'620'}"><span id="button3r" class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($forumstylesurl/default/admin_split.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>$img_txt{'620'}</span></span></span></span></a>$menusep
<a href="javascript:;"><span id="button4l" class="buttonleft" $viewstyleleft title="$img_txt{'121'}"><span id="button4r" class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($forumstylesurl/default/delete.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>$img_txt{'121'}</span></span></span></span></a>
</div>
</td>
</tr>
</table>
~;
}
$viewstyle .= qq~
</add after>

<search for>
	&ToHTML($viewstyle);
</search for>

<add after>
	if($viewcss eq "default") {
		$savecss = "";
	}
	else {
		$savecss = $viewcss;
	}
</add after>

<search for>
			<input type="text" name="savecssas" size="30" maxlength="30" />
</search for>

<replace>
			<input type="text" name="savecssas" size="30" maxlength="30" value="$savecss" />
</replace>

<search for>
function previewColor(thecolor) {
</search for>

<add before>
var buttonurl = '$html_root/Buttons/';

function updateButtons(thebg) {
	len = document.allstyles.selbutton.length;
	for (i = 0; i <len; i++) {
 		document.allstyles.selbutton[i].checked = false;
		if (document.allstyles.selbutton[i].value == thebg) document.allstyles.selbutton[i].checked = true;
	}
	thenewstyle = document.allstyles.stylelink.value;
	cssoption = document.allstyles.buttonleftbg.value;
	newcssoption=cssoption.replace(/(background\\-image\\s*?\\:\.*?\\/Buttons\\/).*?(\\)\\;)/i, "\$1" + thebg + "\$2");
	document.getElementById('butleft').style.backgroundImage = 'url(' + buttonurl + thebg + ')';
	document.allstyles.buttonleftbg.value = newcssoption;
	re=cssoption.replace(/(.*)/, "\$1");
	thenewstyle=thenewstyle.replace(re, newcssoption);
	document.allstyles.stylelink.value = thenewstyle;
	updateStyles();
	btside = '_right';
	cssoption = document.allstyles.buttonrightbg.value;
	newthebg = thebg.replace(/(.*?)\\_left(.*)/i, "\$1" + btside + "\$2");
	newcssoption=cssoption.replace(/(background\\-image\\s*?\\:\.*?\\/Buttons\\/).*?(\\)\\;)/i, "\$1" + newthebg + "\$2");
	document.getElementById('butright').style.backgroundImage = 'url(' + buttonurl + newthebg + ')';
	document.allstyles.buttonrightbg.value = newcssoption;
	re=cssoption.replace(/(.*)/, "\$1");
	thenewstyle=thenewstyle.replace(re, newcssoption);
	document.allstyles.stylelink.value = thenewstyle;
	updateStyles();
}

</add before>

<search for>
	}
	if(cssback.checked) {
</search for>

<add before>
		if(cssoption.match(/\\.buttontext/)) document.getElementById('buttext').style.color = thecolor;
</add before>

<search for>
	updateStyles();
}

function previewFontface() {
</search for>

<add before>
	if(cssoption.match(/\\.buttontext/)) document.getElementById('buttext').style.fontSize = thesize;
</add before>

<search for>
	updateStyles();
}

function previewFontweight() {
</search for>

<add before>
	if(cssoption.match(/\\.buttontext/)) document.getElementById('buttext').style.fontFamily = theface;
</add before>

<search for>
	updateStyles();
}

function previewFontstyle() {
</search for>

<add before>
	if(cssoption.match(/\\.buttontext/)) document.getElementById('buttext').style.fontWeight = thefontweight;
</add before>

<search for>
	updateStyles();
}

function manSelect() {
</search for>

<add before>
	if(cssoption.match(/\\.buttontext/)) document.getElementById('buttext').style.fontStyle = thefontstyle;
</add before>


<search for>
			print TMPCSS "$style_sgl\n";
</search for>

<add before>
			$style_sgl =~ s/$html_root/\.\.\/\.\./g;
</add before>

<search for>
	opendir(TMPLDIR, "$templatesdir");
</search for>

<add before>
	$fullcss =~ s/\s{2,}/ /g;
	if ($fullcss =~ /\.buttontext/) {
		$cssbuttons = 1;
		require "$sourcedir/Menu.pl";
		&SetMenu;
	}
	else {
		$cssbuttons = 0;
		require "$vardir/Menu$UseMenuType.def";
	}

</add before>

<search for>
	if ($UseMenuType == 0) {
		$yimimg = qq~$menusep<img src="$_[1]/yim.gif" alt="" border="0" />~;
		$aimimg = qq~$menusep<img src="$_[1]/aim.gif" alt="" border="0" />~;
		$msnimg = qq~$menusep<img src="$_[1]/msn3.gif" alt="" border="0" />~;
	} elsif ($UseMenuType == 1) {
		$yimimg = qq~$menusep<span class="imgwindowbg">YIM</span>~;
		$aimimg = qq~$menusep<span class="imgwindowbg">AIM</span>~;
		$msnimg = qq~$menusep<span class="imgwindowbg">MSN</span>~;
	} else {
		$yimimg = qq~$menusep<img src="$html_root/Buttons/$language/yim.png" alt="" border="0" />~;
		$aimimg = qq~$menusep<img src="$html_root/Buttons/$language/aim.png" alt="" border="0" />~;
		$msnimg = qq~$menusep<img src="$html_root/Buttons/$language/msn.png" alt="" border="0" />~;
	}
</search for>

<replace>
	if($cssbuttons) {
		if ($UseMenuType == 0) {
			$yimimg = qq~$menusep<img src="$_[1]/yim.gif" alt="" border="0" />~;
			$aimimg = qq~$menusep<img src="$_[1]/aim.gif" alt="" border="0" />~;
			$msnimg = qq~$menusep<img src="$_[1]/msn3.gif" alt="" border="0" />~;
		}
		elsif ($UseMenuType == 1) {
			$yimimg = qq~$menusep<span class="imgwindowbg">YIM</span>~;
			$aimimg = qq~$menusep<span class="imgwindowbg">AIM</span>~;
			$msnimg = qq~$menusep<span class="imgwindowbg">MSN</span>~;
		}
		else {
			$viewstyleleft = qq~style="height: 20px; border: 0px; margin: 1px 1px; background-position: top left; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block;"~;
			$viewstyleright = qq~style="height: 20px; border: 0px; margin: 0px; background-position: top right; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block;"~;
			$viewstyleimage = qq~height: 20px; border: 0px; margin: 0px; background-repeat: no-repeat; vertical-align: top; text-decoration: none; font-size: 18px; display: inline-block;~;
			$viewstyletext = qq~style="height: 20px; border: 0px; margin: 0px; padding: 0px; text-align: left; text-decoration: none; vertical-align: top; white-space: nowrap; display: inline-block;"~;
			$yimimg = qq~<span class="buttonleft"}" $viewstyleleft><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($defaultimagesdir/yim.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>YIM</span></span></span></span>~;
			$aimimg = qq~<span class="buttonleft" $viewstyleleft><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($defaultimagesdir/aim.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>AIM</span></span></span></span>~;
			$msnimg = qq~<span class="buttonleft" $viewstyleleft><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($defaultimagesdir/msn3.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>MSN</span></span></span></span>~;
		}
	}
	else {
		if ($UseMenuType == 0) {
			$yimimg = qq~$menusep<img src="$_[1]/yim.gif" alt="" border="0" />~;
			$aimimg = qq~$menusep<img src="$_[1]/aim.gif" alt="" border="0" />~;
			$msnimg = qq~$menusep<img src="$_[1]/msn3.gif" alt="" border="0" />~;
		}
		elsif ($UseMenuType == 1) {
			$yimimg = qq~$menusep<span class="imgwindowbg">YIM</span>~;
			$aimimg = qq~$menusep<span class="imgwindowbg">AIM</span>~;
			$msnimg = qq~$menusep<span class="imgwindowbg">MSN</span>~;
		}
		else {
			$yimimg = qq~$menusep<img src="$html_root/Buttons/$language/yim.png" alt="" border="0" />~;
			$aimimg = qq~$menusep<img src="$html_root/Buttons/$language/aim.png" alt="" border="0" />~;
			$msnimg = qq~$menusep<img src="$html_root/Buttons/$language/msn.png" alt="" border="0" />~;
		}
	}
</replace>


<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$cssbuttons_mod = qq~CSS Buttons for YaBB 2.2|Carsten|This mod will add "soft coded" css driven buttons to your board and give you the option to change the graphics and text attributes for buttons in the css wysiwyg editor. Added a new extra "Menu.def" to load all 3 menu modes from only one file.|1.0|12/06/07~;
	push (@installed_mods, "$cssbuttons_mod");

</add before>


<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
require "$vardir/Menu$UseMenuType.def";
</search for>

<replace>
if($cssbuttons) {
	require "$sourcedir/Menu.pl";
	&SetMenu;
}
else {
	require "$vardir/Menu$UseMenuType.def";
}
</replace>


<edit file>
Languages/English/Templates.lng
</edit file>

<search for>
);
</search for>

<add before>
'buttontext' => 'CSS Buttons',
'buttondescription' => 'Here you can change the position of the icon and text inside the buttons and the background graphics for the buttons.',
'moveicon1' => 'Icon down',
'moveicon2' => 'Icon right',
'iconspace' => 'Icon space',
'movetext' => 'Text down',
</add before>


<edit file>
Sources/Load.pl
</edit file>

<search for>
		$yimimg   = qq~<img src="$html_root/Buttons/$language/yim.png" alt="${$uid.$user}{'yim'}" border="0" />~;
		$aimimg   = qq~<img src="$html_root/Buttons/$language/aim.png" alt="${$uid.$user}{'aim'}" border="0" />~;
		$skypeimg = qq~<img src="$html_root/Buttons/$language/skype.png" alt="${$uid.$user}{'skype'}" border="0" />~;
		$msnimg   = qq~<img src="$html_root/Buttons/$language/msn.png" style="cursor: pointer" onclick="window.open('$scripturl?action=setmsn;msnname=$themsnuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false" alt="$themsnname" border="0" />~;
		$gtalkimg = qq~<img src="$html_root/Buttons/$language/gtalk.png" style="cursor: pointer" onclick="window.open('$scripturl?action=setgtalk;gtalkname=$thegtalkuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false" alt="$thegtalkname" border="0" />~;
		$icqimg   = qq~<img src="$html_root/Buttons/$language/icq.png" alt="${$uid.$user}{'icq'}" border="0" />~;
</search for>

<replace>
		if($cssbuttons) {
			$viewstyleleft = qq~style="height: 20px; border: 0px; margin: 1px 1px; background-position: top left; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; cursor: pointer; display: inline-block;"~;
			$viewstyleright = qq~style="height: 20px; border: 0px; margin: 0px; background-position: top right; background-repeat: no-repeat; text-decoration: none; font-size: 18px; vertical-align: top; display: inline-block;"~;
			$viewstyleimage = qq~height: 20px; border: 0px; margin: 0px; background-repeat: no-repeat; vertical-align: top; text-decoration: none; font-size: 18px; display: inline-block;~;
			$viewstyletext = qq~style="height: 20px; border: 0px; margin: 0px; padding: 0px; text-align: left; text-decoration: none; vertical-align: top; white-space: nowrap; display: inline-block;"~;
			$yimmsgimagedir = $imagesdir; if(!-e("$yimmsgimagedir/yim.gif")) { $yimmsgimagedir = $defaultimagesdir; }
			$aimmsgimagedir = $imagesdir; if(!-e("$aimmsgimagedir/aim.gif")) { $aimmsgimagedir = $defaultimagesdir; }
			$skymsgimagedir = $imagesdir; if(!-e("$skymsgimagedir/skype.gif")) { $skymsgimagedir = $defaultimagesdir; }
			$msnmsgimagedir = $imagesdir; if(!-e("$msnmsgimagedir/msn3.gif")) { $msnmsgimagedir = $defaultimagesdir; }
			$gtkmsgimagedir = $imagesdir; if(!-e("$gtkmsgimagedir/gtalk2.gif")) { $gtkmsgimagedir = $defaultimagesdir; }
			$icqmsgimagedir = $imagesdir; if(!-e("$icqmsgimagedir/icqadd.gif")) { $icqmsgimagedir = $defaultimagesdir; }
			$yimimg = qq~<span class="buttonleft" $viewstyleleft title="${$uid.$user}{'yim'}"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($yimmsgimagedir/yim.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>YIM</span></span></span></span>~;
			$aimimg = qq~<span class="buttonleft" $viewstyleleft title="${$uid.$user}{'aim'}"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($aimmsgimagedir/aim.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>AIM</span></span></span></span>~;
			$skypeimg = qq~<span class="buttonleft" $viewstyleleft title="${$uid.$user}{'skype'}"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($skymsgimagedir/skype.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>Skype</span></span></span></span>~;
			$msnimg = qq~<span class="buttonleft" $viewstyleleft title="$themsnname" onclick="window.open('$scripturl?action=setmsn;msnname=$themsnuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($msnmsgimagedir/msn3.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>MSN</span></span></span></span>~;
			$gtalkimg = qq~<span class="buttonleft" $viewstyleleft title="$thegtalkname" onclick="window.open('$scripturl?action=setgtalk;gtalkname=$thegtalkuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($gtkmsgimagedir/gtalk2.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>Gtalk</span></span></span></span>~;
			$icqimg = qq~<span class="buttonleft" $viewstyleleft title="${$uid.$user}{'icq'}"><span class="buttonright" $viewstyleright><span class="buttonimage" style="background-image: url($icqmsgimagedir/icqadd.gif); $viewstyleimage"><span class="buttontext" $viewstyletext>ICQ</span></span></span></span>~;
		}
		else {
			$yimimg   = qq~<img src="$html_root/Buttons/$language/yim.png" alt="${$uid.$user}{'yim'}" border="0" />~;
			$aimimg   = qq~<img src="$html_root/Buttons/$language/aim.png" alt="${$uid.$user}{'aim'}" border="0" />~;
			$skypeimg = qq~<img src="$html_root/Buttons/$language/skype.png" alt="${$uid.$user}{'skype'}" border="0" />~;
			$msnimg   = qq~<img src="$html_root/Buttons/$language/msn.png" style="cursor: pointer" onclick="window.open('$scripturl?action=setmsn;msnname=$themsnuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false" alt="$themsnname" border="0" />~;
			$gtalkimg = qq~<img src="$html_root/Buttons/$language/gtalk.png" style="cursor: pointer" onclick="window.open('$scripturl?action=setgtalk;gtalkname=$thegtalkuser','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false" alt="$thegtalkname" border="0" />~;
			$icqimg   = qq~<img src="$html_root/Buttons/$language/icq.png" alt="${$uid.$user}{'icq'}" border="0" />~;
		}
</replace>

<search for>
	$extpagstyle =~ s~$usestyle\/~~g;
</search for>

<add after>
	$cssbuttons = 0;
	fopen(CSS, "$forumstylesdir/$usestyle.css");
	@thecss = <CSS>;
	fclose(CSS);
	foreach $style_sgl (@thecss) {
		$style_sgl =~ s/[\n\r]//g;
		$style_sgl =~ s/\A\s*//;
		$style_sgl =~ s/\s*\Z//;
		$style_sgl =~ s/\t//g;
		$stylestr .= qq~$style_sgl ~;
	}
	$stylestr =~ s/\s{2,}/ /g;
	if ($stylestr =~ /\.buttonleft/ && $stylestr =~ /\.buttonright/ && $stylestr =~ /\.buttonimage/ && $stylestr =~ /\.buttontext/) {
		$cssbuttons = 1;
	}
</add after>
